//+------------------------------------------------------------------+
//|                                                         grid.mq4 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
extern   double   Lot=0.1;
extern   double   TradeQty=100;
extern   double   BuyBelow=1.16;
extern   double   SellAbove=1.11;
extern   int      Magic=1234;
extern   double   space=0.0005;
extern   int      TP=100;
extern   int      SL=10000;
extern   int      trail=0;
extern   int      breakeven=0;

void start()
  {
//---
tpsl();
   for(int i=0;i<=(BuyBelow-SellAbove)/space;i++)
     {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderLots()<Lot)
              {
                 OrderSend(Symbol(),OP_BUYSTOP,Lot,BuyBelow-i*space,0,0,0,0,Magic,0,Green); 
              }

          OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
          if(OrderLots()<Lot)

              {
                 OrderSend(Symbol(),OP_SELLSTOP,Lot,SellAbove+i*space,0,0,0,0,Magic,0,Red); 
              }
     }
  for(int j=0;j<OrdersTotal();j++)
     {
      OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // check for trailing stop
            if(trail>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*trail)
                 {
                  if(OrderStopLoss()<Bid-Point*trail)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*trail,OrderTakeProfit(),0,Green);
                    }
                 }
              }
           }
         else // go to short position
           {
            // check for trailing stop
            if(trail>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*trail))
                 {
                  if((OrderStopLoss()>(Ask+Point*trail)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*trail,OrderTakeProfit(),0,Red);
                    }
                 }
              }
           }
        }
       }
  
  
  for(int k=0;k<OrdersTotal();k++)
     {
      OrderSelect(k, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // check for trailing stop
            if(breakeven>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*breakeven)
                 {
                  if(OrderStopLoss()<Bid-Point*breakeven)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
                    }
                 }
              }
           }
         else // go to short position
           {
            // check for trailing stop
            if(breakeven>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*breakeven))
                 {
                  if((OrderStopLoss()>(Ask+Point*breakeven)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
                    }
                 }
              }
           }
        }
       } 
  
  
   }
//+------------------------------------------------------------------+
void tpsl()
{
double tp=0;
double sl=0;
for(int i=0;i<OrdersTotal();i++)
  {
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
     {
      if(OrderType()==OP_BUYSTOP)
        {
//         OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-SL*Point,OrderOpenPrice()+TP*Point,0,0);

         OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderOpenPrice()+TP*Point,0,0);
        }
      if(OrderType()==OP_SELLSTOP)
        {
//         OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+SL*Point,OrderOpenPrice()-TP*Point,0,0);

         OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderOpenPrice()-TP*Point,0,0);
        }
     }
  }
}

 
      
 